/*
* chsums/0q5g-static.cpp
*
* This file is part of NJet library
* Copyright (C) 2011, 2012 NJet Collaboration
*
* This software is distributed under the terms of the GNU General Public License (GPL)
*/

#include <cassert>

#include "0q5g.h"

// class Amp0q5gStatic

const int
Amp0q5gStatic::flav[FC][NN] = {
  {0,0,0,0,0}
};

const int
Amp0q5gStatic::fvsign[FC] = {1};

const int
Amp0q5gStatic::ccsign[NN*(NN+1)/2] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};

const int
Amp0q5gStatic::fperm[FC][NN] = {
  {0,1,2,3,4}
};

const int
Amp0q5gStatic::fvcol[FC][C0] = {
  {0,1,2,3,4,5}
};

const unsigned char
Amp0q5gStatic::colmat[C0*(C0+1)/2] = {
  3,2,3,2,1,3,1,0,2,3,1,2,0,1,3,0,1,1,2,2,3
};

const unsigned char
Amp0q5gStatic::colmatcc[NN*(NN+1)/2][C0*(C0+1)/2] = {
  {},
  {1,0,1,0,6,1,6,6,0,1,6,0,6,6,1,6,6,6,0,0,1},
  {},
  {1,0,1,1,5,2,1,0,2,3,5,1,5,1,2,0,1,1,2,2,3},
  {3,2,3,2,1,2,1,0,1,1,1,2,5,5,2,0,1,5,0,1,1},
  {},
  {2,2,3,1,1,1,5,0,0,1,1,2,0,1,3,5,1,5,1,2,2},
  {2,1,1,2,1,3,1,0,2,3,5,0,0,1,1,5,5,1,2,1,2},
  {2,1,1,0,0,2,0,5,1,1,4,1,6,0,2,6,0,4,1,0,2},
  {},
  {3,2,2,2,1,3,1,5,2,2,1,1,0,5,1,0,5,1,1,0,1},
  {1,1,2,0,5,1,5,5,1,2,1,2,0,1,3,0,1,1,2,2,3},
  {1,1,2,1,4,2,0,6,0,2,0,0,6,4,2,5,0,0,1,1,1},
  {2,0,2,1,0,1,4,6,1,2,0,1,5,0,1,6,4,0,0,1,2},
  {},
};

const unsigned int Amp0q5gStatic::colmatds[CDS][C0] = {
  // L
  {1, 0, 0, 3, 3, 3},
  {3, 3, 0, 1, 3, 0},
  {3, 0, 3, 3, 1, 0},
  {2, 0, 2, 2, 3, 0},
  {0, 4, 1, 1, 0, 1},
  {4, 4, 4, 0, 0, 2},
  {3, 0, 0, 2, 2, 2},
  {0, 1, 4, 0, 1, 1},
  {0, 2, 4, 4, 0, 4},
  {2, 2, 0, 3, 2, 0},
  {1, 1, 1, 0, 0, 4},
  {0, 4, 2, 0, 4, 4},
  // F
  {2, 0, 0, 6, 6, 6},
  {6, 6, 0, 2, 6, 0},
  {6, 0, 6, 6, 2, 0},
  {1, 0, 1, 1, 6, 0},
  {0, 5, 2, 2, 0, 2},
  {5, 5, 5, 0, 0, 1},
  {6, 0, 0, 1, 1, 1},
  {0, 2, 5, 0, 2, 2},
  {0, 1, 5, 5, 0, 5},
  {1, 1, 0, 6, 1, 0},
  {2, 2, 2, 0, 0, 5},
  {0, 5, 1, 0, 5, 5},
};

const int
Amp0q5gStatic::HSarr[HS][HSNN] = {
//   { 1, 1, 1, 1, 1},
//   { 1, 1, 1, 1,-1},
//   { 1, 1, 1,-1, 1},
  { 1, 1, 1,-1,-1},
//   { 1, 1,-1, 1, 1},
  { 1, 1,-1, 1,-1},
  { 1, 1,-1,-1, 1},
  { 1, 1,-1,-1,-1},
//   {-1, 1, 1, 1, 1},
  {-1, 1, 1, 1,-1},
  {-1, 1, 1,-1, 1},
  {-1, 1, 1,-1,-1},
  {-1, 1,-1, 1, 1},
  {-1, 1,-1, 1,-1},
  {-1, 1,-1,-1, 1},
//   {-1, 1,-1,-1,-1},
//   {-1,-1,-1,-1,-1},
//   {-1,-1,-1,-1, 1},
//   {-1,-1,-1, 1,-1},
  {-1,-1,-1, 1, 1},
//   {-1,-1, 1,-1,-1},
  {-1,-1, 1,-1, 1},
  {-1,-1, 1, 1,-1},
  {-1,-1, 1, 1, 1},
//   { 1,-1,-1,-1,-1},
  { 1,-1,-1,-1, 1},
  { 1,-1,-1, 1,-1},
  { 1,-1,-1, 1, 1},
  { 1,-1, 1,-1,-1},
  { 1,-1, 1,-1, 1},
  { 1,-1, 1, 1,-1},
//   { 1,-1, 1, 1, 1},
};

// class Amp0q5g_ds3Static

const unsigned int Amp0q5g_ds3Static::colmatds[CDS][C0] = {
  // L
  {1, 0, 0, 3, 3, 3},
  {2, 0, 2, 2, 3, 0},
  {0, 4, 1, 1, 0, 1},
  {4, 4, 4, 0, 0, 2},
  // F
  {2, 0, 0, 6, 6, 6},
  {1, 0, 1, 1, 6, 0},
  {0, 5, 2, 2, 0, 2},
  {5, 5, 5, 0, 0, 1},
};
