/*
* chsums/4q1gA-static.cpp
*
* This file is part of NJet library
* Copyright (C) 2011, 2012 NJet Collaboration
*
* This software is distributed under the terms of the GNU General Public License (GPL)
*/

#include "4q1gA.h"

// class Amp4q1gAxStatic

const int
Amp4q1gAxStatic::flav[FC][NN] = {
    {-1,1,-2,2,0}, // ax
    {-1,1,-2,2,0},
    {-2,2,-1,1,0},
    {-1,2,-2,1,0}, // ax
    {-1,2,-2,1,0},
    {-2,1,-1,2,0}
};

const int
Amp4q1gAxStatic::fvsign[FC] = {1, 1, 1,-1,-1,-1};

const int
Amp4q1gAxStatic::fperm[FC][NN] = {
    {0,1,2,3,4}, // ax
    {0,1,2,3,4},
    {2,3,0,1,4},
    {0,3,2,1,4}, // ax
    {0,3,2,1,4},
    {2,1,0,3,4}
};

const int
Amp4q1gAxStatic::fvcol[FC][CC] = {
    {0,1,2,3}, // ax
    {0,1,2,3},
    {1,0,3,2},
    {2,3,0,1}, // ax
    {2,3,0,1},
    {3,2,1,0},
};

// class Amp4q1gAx2Static

const int
Amp4q1gAx2Static::HSarr[HS][HSNN] = {
  { 1,-1,-1, 1, 1, 1},
  { 1,-1,-1, 1,-1, 1},
  { 1,-1, 1,-1, 1, 1},
  { 1,-1, 1,-1,-1, 1},
  {-1,-1, 1, 1, 1, 1},
  {-1,-1, 1, 1,-1, 1},
  {-1, 1,-1, 1, 1, 1},
  {-1, 1,-1, 1,-1, 1},
  {-1, 1, 1,-1, 1, 1},
  {-1, 1, 1,-1,-1, 1},
  { 1, 1,-1,-1, 1, 1},
  { 1, 1,-1,-1,-1, 1},
  { 1,-1,-1, 1, 1,-1},
  { 1,-1,-1, 1,-1,-1},
  { 1,-1, 1,-1, 1,-1},
  { 1,-1, 1,-1,-1,-1},
  {-1,-1, 1, 1, 1,-1},
  {-1,-1, 1, 1,-1,-1},
  {-1, 1,-1, 1, 1,-1},
  {-1, 1,-1, 1,-1,-1},
  {-1, 1, 1,-1, 1,-1},
  {-1, 1, 1,-1,-1,-1},
  { 1, 1,-1,-1, 1,-1},
  { 1, 1,-1,-1,-1,-1},
};

// class Amp4q1gAAStatic

const int
Amp4q1gAAStatic::flav[FC][NN] = {
    {-1,1,-2,2,0},
    {-1,1,-2,2,0},
    {-2,2,-1,1,0},
    {-2,2,-1,1,0},
    {-1,2,-2,1,0},
    {-1,2,-2,1,0},
    {-2,1,-1,2,0},
    {-2,1,-1,2,0},
};

const int
Amp4q1gAAStatic::fvsign[FC] = {1, 1, 1, 1,-1,-1,-1,-1};

const int
Amp4q1gAAStatic::fperm[FC][NN] = {
    {0,1,2,3,4},
    {0,1,2,3,4},
    {2,3,0,1,4},
    {2,3,0,1,4},
    {0,3,2,1,4},
    {0,3,2,1,4},
    {2,1,0,3,4},
    {2,1,0,3,4},
};

const int
Amp4q1gAAStatic::fvcol[FC][CC] = {
    {0,1,2,3},
    {0,1,2,3},
    {1,0,3,2},
    {1,0,3,2},
    {2,3,0,1},
    {2,3,0,1},
    {3,2,1,0},
    {3,2,1,0},
};

const int
Amp4q1gAAStatic::HSarr[HS][HSNN] = {
  { 1,-1,-1, 1, 1, 1, 1},
  { 1,-1,-1, 1,-1, 1, 1},
  { 1,-1, 1,-1, 1, 1, 1},
  { 1,-1, 1,-1,-1, 1, 1},
  {-1, 1,-1, 1, 1, 1, 1},
  {-1, 1,-1, 1,-1, 1, 1},
  {-1, 1, 1,-1, 1, 1, 1},
  {-1, 1, 1,-1,-1, 1, 1},
  { 1,-1,-1, 1, 1,-1, 1},
  { 1,-1,-1, 1,-1,-1, 1},
  { 1,-1, 1,-1, 1,-1, 1},
  { 1,-1, 1,-1,-1,-1, 1},
  {-1, 1,-1, 1, 1,-1, 1},
  {-1, 1,-1, 1,-1,-1, 1},
  {-1, 1, 1,-1, 1,-1, 1},
  {-1, 1, 1,-1,-1,-1, 1},
  { 1,-1,-1, 1, 1, 1,-1},
  { 1,-1,-1, 1,-1, 1,-1},
  { 1,-1, 1,-1, 1, 1,-1},
  { 1,-1, 1,-1,-1, 1,-1},
  {-1, 1,-1, 1, 1, 1,-1},
  {-1, 1,-1, 1,-1, 1,-1},
  {-1, 1, 1,-1, 1, 1,-1},
  {-1, 1, 1,-1,-1, 1,-1},
  { 1,-1,-1, 1, 1,-1,-1},
  { 1,-1,-1, 1,-1,-1,-1},
  { 1,-1, 1,-1, 1,-1,-1},
  { 1,-1, 1,-1,-1,-1,-1},
  {-1, 1,-1, 1, 1,-1,-1},
  {-1, 1,-1, 1,-1,-1,-1},
  {-1, 1, 1,-1, 1,-1,-1},
  {-1, 1, 1,-1,-1,-1,-1},
};

// class Amp4q1gAA2Static

const int
Amp4q1gAA2Static::HSarr[HS][HSNN] = {
  { 1,-1,-1, 1, 1, 1, 1},
  { 1,-1,-1, 1,-1, 1, 1},
  { 1,-1, 1,-1, 1, 1, 1},
  { 1,-1, 1,-1,-1, 1, 1},
  {-1,-1, 1, 1, 1, 1, 1},
  {-1,-1, 1, 1,-1, 1, 1},
  {-1, 1,-1, 1, 1, 1, 1},
  {-1, 1,-1, 1,-1, 1, 1},
  {-1, 1, 1,-1, 1, 1, 1},
  {-1, 1, 1,-1,-1, 1, 1},
  { 1, 1,-1,-1, 1, 1, 1},
  { 1, 1,-1,-1,-1, 1, 1},
  { 1,-1,-1, 1, 1,-1, 1},
  { 1,-1,-1, 1,-1,-1, 1},
  { 1,-1, 1,-1, 1,-1, 1},
  { 1,-1, 1,-1,-1,-1, 1},
  {-1,-1, 1, 1, 1,-1, 1},
  {-1,-1, 1, 1,-1,-1, 1},
  {-1, 1,-1, 1, 1,-1, 1},
  {-1, 1,-1, 1,-1,-1, 1},
  {-1, 1, 1,-1, 1,-1, 1},
  {-1, 1, 1,-1,-1,-1, 1},
  { 1, 1,-1,-1, 1,-1, 1},
  { 1, 1,-1,-1,-1,-1, 1},
  { 1,-1,-1, 1, 1, 1,-1},
  { 1,-1,-1, 1,-1, 1,-1},
  { 1,-1, 1,-1, 1, 1,-1},
  { 1,-1, 1,-1,-1, 1,-1},
  {-1,-1, 1, 1, 1, 1,-1},
  {-1,-1, 1, 1,-1, 1,-1},
  {-1, 1,-1, 1, 1, 1,-1},
  {-1, 1,-1, 1,-1, 1,-1},
  {-1, 1, 1,-1, 1, 1,-1},
  {-1, 1, 1,-1,-1, 1,-1},
  { 1, 1,-1,-1, 1, 1,-1},
  { 1, 1,-1,-1,-1, 1,-1},
  { 1,-1,-1, 1, 1,-1,-1},
  { 1,-1,-1, 1,-1,-1,-1},
  { 1,-1, 1,-1, 1,-1,-1},
  { 1,-1, 1,-1,-1,-1,-1},
  {-1,-1, 1, 1, 1,-1,-1},
  {-1,-1, 1, 1,-1,-1,-1},
  {-1, 1,-1, 1, 1,-1,-1},
  {-1, 1,-1, 1,-1,-1,-1},
  {-1, 1, 1,-1, 1,-1,-1},
  {-1, 1, 1,-1,-1,-1,-1},
  { 1, 1,-1,-1, 1,-1,-1},
  { 1, 1,-1,-1,-1,-1,-1},
};
