/*
* chsums/4q1gV-static.cpp
*
* This file is part of NJet library
* Copyright (C) 2011, 2012, 2013 NJet Collaboration
*
* This software is distributed under the terms of the GNU General Public License (GPL)
*/

#include "4q1gV.h"

// class Amp4q1gVStatic

const int
Amp4q1gVStatic::HSarr[HS][HSNN] = {
  { 1,-1,-1, 1, 1, 1}, { 1,-1,-1, 1,-1, 1},
  { 1,-1, 1,-1, 1, 1}, { 1,-1, 1,-1,-1, 1},
};

// class Amp4q1gV2Static

const int
Amp4q1gV2Static::HSarr[HS][HSNN] = {
  { 1,-1,-1, 1, 1, 1}, { 1,-1,-1, 1,-1, 1},
  { 1,-1, 1,-1, 1, 1}, { 1,-1, 1,-1,-1, 1},
  { 1, 1,-1,-1, 1, 1}, { 1, 1,-1,-1,-1, 1},
};

// class Amp4q1gV2bStatic

const int
Amp4q1gV2bStatic::HSarr[HS][HSNN] = {
  { 1,-1,-1, 1, 1, 1}, { 1,-1,-1, 1,-1, 1},
  { 1,-1, 1,-1, 1, 1}, { 1,-1, 1,-1,-1, 1},
  {-1,-1, 1, 1, 1, 1}, {-1,-1, 1, 1,-1, 1},
};

const int
Amp4q1gV2bStatic::flav[FC][NN] = {
    {-1,1,-2,2,0},
    {-2,1,-1,2,0},
};

const int
Amp4q1gV2bStatic::fperm[FC][NN] = {
    {0,1,2,3,4},
    {2,1,0,3,4},
};

const int
Amp4q1gV2bStatic::fvcol[FC][CC] = {
    {0,1,2,3},
    {3,2,1,0},
};

// class Amp4q1gZStatic

const int
Amp4q1gZStatic::flav[FC][NN] = {
    {-1,1,-2,2,0},
    {-2,2,-1,1,0},
    {-1,2,-2,1,0},
    {-2,1,-1,2,0}
};

const int
Amp4q1gZStatic::fvsign[FC] = {1, 1,-1,-1};

const int
Amp4q1gZStatic::fperm[FC][NN] = {
    {0,1,2,3,4},
    {2,3,0,1,4},
    {0,3,2,1,4},
    {2,1,0,3,4}
};

const int
Amp4q1gZStatic::fvcol[FC][CC] = {
    {0,1,2,3},
    {1,0,3,2},
    {2,3,0,1},
    {3,2,1,0},
};

const int
Amp4q1gZStatic::HSarr[HS][HSNN] = {
  { 1,-1,-1, 1, 1, 1}, { 1,-1,-1, 1,-1, 1},
  { 1,-1, 1,-1, 1, 1}, { 1,-1, 1,-1,-1, 1},
  {-1, 1,-1, 1, 1, 1}, {-1, 1,-1, 1,-1, 1},
  {-1, 1, 1,-1, 1, 1}, {-1, 1, 1,-1,-1, 1},
  { 1,-1,-1, 1, 1,-1}, { 1,-1,-1, 1,-1,-1},
  { 1,-1, 1,-1, 1,-1}, { 1,-1, 1,-1,-1,-1},
  {-1, 1,-1, 1, 1,-1}, {-1, 1,-1, 1,-1,-1},
  {-1, 1, 1,-1, 1,-1}, {-1, 1, 1,-1,-1,-1},
};

const int
Amp4q1gZ2Static::HSarr[HS][HSNN] = {
  { 1,-1,-1, 1, 1, 1}, { 1,-1,-1, 1,-1, 1},
  { 1,-1, 1,-1, 1, 1}, { 1,-1, 1,-1,-1, 1},
  {-1,-1, 1, 1, 1, 1}, {-1,-1, 1, 1,-1, 1},
  {-1, 1,-1, 1, 1, 1}, {-1, 1,-1, 1,-1, 1},
  {-1, 1, 1,-1, 1, 1}, {-1, 1, 1,-1,-1, 1},
  { 1, 1,-1,-1, 1, 1}, { 1, 1,-1,-1,-1, 1},
  { 1,-1,-1, 1, 1,-1}, { 1,-1,-1, 1,-1,-1},
  { 1,-1, 1,-1, 1,-1}, { 1,-1, 1,-1,-1,-1},
  {-1,-1, 1, 1, 1,-1}, {-1,-1, 1, 1,-1,-1},
  {-1, 1,-1, 1, 1,-1}, {-1, 1,-1, 1,-1,-1},
  {-1, 1, 1,-1, 1,-1}, {-1, 1, 1,-1,-1,-1},
  { 1, 1,-1,-1, 1,-1}, { 1, 1,-1,-1,-1,-1},
};
