/*
* chsums/4q2gV-static.cpp
*
* This file is part of NJet library
* Copyright (C) 2011, 2012 NJet Collaboration
*
* This software is distributed under the terms of the GNU General Public License (GPL)
*/

#include "4q2gV.h"

// class Amp4q2gVStatic

const int
Amp4q2gVStatic::HSarr[HS][HSNN] = {
  { 1,-1, 1,-1, 1, 1, 1}, { 1,-1, 1,-1, 1,-1, 1}, { 1,-1, 1,-1,-1, 1, 1}, { 1,-1, 1,-1,-1,-1, 1},
  { 1,-1,-1, 1, 1, 1, 1}, { 1,-1,-1, 1, 1,-1, 1}, { 1,-1,-1, 1,-1, 1, 1}, { 1,-1,-1, 1,-1,-1, 1},
};

// class Amp4q2gV2Static

const int
Amp4q2gV2Static::HSarr[HS][HSNN] = {
  { 1,-1, 1,-1, 1, 1, 1}, { 1,-1, 1,-1, 1,-1, 1}, { 1,-1, 1,-1,-1, 1, 1}, { 1,-1, 1,-1,-1,-1, 1},
  { 1,-1,-1, 1, 1, 1, 1}, { 1,-1,-1, 1, 1,-1, 1}, { 1,-1,-1, 1,-1, 1, 1}, { 1,-1,-1, 1,-1,-1, 1},
  { 1, 1,-1,-1, 1, 1, 1}, { 1, 1,-1,-1, 1,-1, 1}, { 1, 1,-1,-1,-1, 1, 1}, { 1, 1,-1,-1,-1,-1, 1},
};

// class Amp4q2gV2bStatic

const int
Amp4q2gV2bStatic::HSarr[HS][HSNN] = {
  { 1,-1, 1,-1, 1, 1, 1}, { 1,-1, 1,-1, 1,-1, 1}, { 1,-1, 1,-1,-1, 1, 1}, { 1,-1, 1,-1,-1,-1, 1},
  { 1,-1,-1, 1, 1, 1, 1}, { 1,-1,-1, 1, 1,-1, 1}, { 1,-1,-1, 1,-1, 1, 1}, { 1,-1,-1, 1,-1,-1, 1},
  {-1,-1, 1, 1,-1,-1, 1}, {-1,-1, 1, 1,-1, 1, 1}, {-1,-1, 1, 1, 1,-1, 1}, {-1,-1, 1, 1, 1, 1, 1},
};

const int
Amp4q2gV2bStatic::flav[FC][NN] = {
    {-1,1,-2,2,0,0},
    {-2,1,-1,2,0,0},
};

const int
Amp4q2gV2bStatic::fperm[FC][NN] = {
    {0,1,2,3,4,5},
    {2,1,0,3,4,5},
};

const int
Amp4q2gV2bStatic::fvcol[FC][CC] = {
    {0,1,2,3,4,5,6,7,8,9,10,11,12,13},
    {11,7,9,8,10,6,5,1,3,2,4,0,13,12},
};

// class Amp4q2gZStatic

const int
Amp4q2gZStatic::flav[FC][NN] = {
    {-1,1,-2,2,0,0},
    {-2,2,-1,1,0,0},
    {-1,2,-2,1,0,0},
    {-2,1,-1,2,0,0}
};

const int
Amp4q2gZStatic::fvsign[FC] = {1, 1,-1,-1};

const int
Amp4q2gZStatic::fperm[FC][NN] = {
    {0,1,2,3,4,5},
    {2,3,0,1,4,5},
    {0,3,2,1,4,5},
    {2,1,0,3,4,5}
};

const int
Amp4q2gZStatic::fvcol[FC][CC] = {
  {0,1,2,3,4,5,6,7,8,9,10,11,12,13},
  {2,4,0,5,1,3,8,10,6,11,7,9,12,13},
  {9,10,11,6,7,8,3,4,5,0,1,2,13,12},
  {11,7,9,8,10,6,5,1,3,2,4,0,13,12},
};

const int
Amp4q2gZStatic::HSarr[HS][HSNN] = {
  { 1,-1,-1, 1, 1, 1, 1}, { 1,-1,-1, 1, 1,-1, 1}, { 1,-1,-1, 1,-1, 1, 1}, { 1,-1,-1, 1,-1,-1, 1},
  { 1,-1, 1,-1, 1, 1, 1}, { 1,-1, 1,-1, 1,-1, 1}, { 1,-1, 1,-1,-1, 1, 1}, { 1,-1, 1,-1,-1,-1, 1},
  {-1, 1,-1, 1, 1, 1, 1}, {-1, 1,-1, 1, 1,-1, 1}, {-1, 1,-1, 1,-1, 1, 1}, {-1, 1,-1, 1,-1,-1, 1},
  {-1, 1, 1,-1, 1, 1, 1}, {-1, 1, 1,-1, 1,-1, 1}, {-1, 1, 1,-1,-1, 1, 1}, {-1, 1, 1,-1,-1,-1, 1},
  { 1,-1,-1, 1, 1, 1,-1}, { 1,-1,-1, 1, 1,-1,-1}, { 1,-1,-1, 1,-1, 1,-1}, { 1,-1,-1, 1,-1,-1,-1},
  { 1,-1, 1,-1, 1, 1,-1}, { 1,-1, 1,-1, 1,-1,-1}, { 1,-1, 1,-1,-1, 1,-1}, { 1,-1, 1,-1,-1,-1,-1},
  {-1, 1,-1, 1, 1, 1,-1}, {-1, 1,-1, 1, 1,-1,-1}, {-1, 1,-1, 1,-1, 1,-1}, {-1, 1,-1, 1,-1,-1,-1},
  {-1, 1, 1,-1, 1, 1,-1}, {-1, 1, 1,-1, 1,-1,-1}, {-1, 1, 1,-1,-1, 1,-1}, {-1, 1, 1,-1,-1,-1,-1},
};

const int
Amp4q2gZ2Static::HSarr[HS][HSNN] = {
  { 1,-1, 1,-1, 1, 1, 1}, { 1,-1, 1,-1, 1,-1, 1}, { 1,-1, 1,-1,-1, 1, 1}, { 1,-1, 1,-1,-1,-1, 1},
  { 1,-1,-1, 1, 1, 1, 1}, { 1,-1,-1, 1, 1,-1, 1}, { 1,-1,-1, 1,-1, 1, 1}, { 1,-1,-1, 1,-1,-1, 1},
  { 1, 1,-1,-1, 1, 1, 1}, { 1, 1,-1,-1, 1,-1, 1}, { 1, 1,-1,-1,-1, 1, 1}, { 1, 1,-1,-1,-1,-1, 1},
  {-1, 1,-1, 1, 1, 1, 1}, {-1, 1,-1, 1, 1,-1, 1}, {-1, 1,-1, 1,-1, 1, 1}, {-1, 1,-1, 1,-1,-1, 1},
  {-1, 1, 1,-1, 1, 1, 1}, {-1, 1, 1,-1, 1,-1, 1}, {-1, 1, 1,-1,-1, 1, 1}, {-1, 1, 1,-1,-1,-1, 1},
  {-1,-1, 1, 1,-1,-1, 1}, {-1,-1, 1, 1,-1, 1, 1}, {-1,-1, 1, 1, 1,-1, 1}, {-1,-1, 1, 1, 1, 1, 1},
  { 1,-1, 1,-1, 1, 1,-1}, { 1,-1, 1,-1, 1,-1,-1}, { 1,-1, 1,-1,-1, 1,-1}, { 1,-1, 1,-1,-1,-1,-1},
  { 1,-1,-1, 1, 1, 1,-1}, { 1,-1,-1, 1, 1,-1,-1}, { 1,-1,-1, 1,-1, 1,-1}, { 1,-1,-1, 1,-1,-1,-1},
  { 1, 1,-1,-1, 1, 1,-1}, { 1, 1,-1,-1, 1,-1,-1}, { 1, 1,-1,-1,-1, 1,-1}, { 1, 1,-1,-1,-1,-1,-1},
  {-1, 1,-1, 1, 1, 1,-1}, {-1, 1,-1, 1, 1,-1,-1}, {-1, 1,-1, 1,-1, 1,-1}, {-1, 1,-1, 1,-1,-1,-1},
  {-1, 1, 1,-1, 1, 1,-1}, {-1, 1, 1,-1, 1,-1,-1}, {-1, 1, 1,-1,-1, 1,-1}, {-1, 1, 1,-1,-1,-1,-1},
  {-1,-1, 1, 1,-1,-1,-1}, {-1,-1, 1, 1,-1, 1,-1}, {-1,-1, 1, 1, 1,-1,-1}, {-1,-1, 1, 1, 1, 1,-1},
};
